/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.source.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.etools.c.source.CBlock;
import com.ibm.etools.c.source.SourcePackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>CBlock</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link com.ibm.etools.c.source.impl.CBlockImpl#getSource <em>Source</em>}
 * </li>
 * <li>{@link com.ibm.etools.c.source.impl.CBlockImpl#getNests <em>Nests</em>}
 * </li>
 * <li>
 * {@link com.ibm.etools.c.source.impl.CBlockImpl#getNested <em>Nested</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class CBlockImpl extends EObjectImpl implements CBlock {
    /**
     * The default value of the '{@link #getSource() <em>Source</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getSource()
     * @generated @ordered
     */
    protected static final String SOURCE_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getSource() <em>Source</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getSource()
     * @generated @ordered
     */
    protected String source = SOURCE_EDEFAULT;

    /**
     * The cached value of the '{@link #getNested() <em>Nested</em>}'
     * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getNested()
     * @generated @ordered
     */
    protected EList nested = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CBlockImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return SourcePackage.eINSTANCE.getCBlock();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String getSource() {
        return source;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSource(String newSource) {
        String oldSource = source;
        source = newSource;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, SourcePackage.CBLOCK__SOURCE, oldSource, source));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CBlock getNests() {
        if (eContainerFeatureID != SourcePackage.CBLOCK__NESTS)
            return null;
        return (CBlock) eContainer;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setNests(CBlock newNests) {
        if (newNests != eContainer || (eContainerFeatureID != SourcePackage.CBLOCK__NESTS && newNests != null)) {
            if (EcoreUtil.isAncestor(this, newNests))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eContainer != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newNests != null)
                msgs = ((InternalEObject) newNests).eInverseAdd(this, SourcePackage.CBLOCK__NESTED, CBlock.class, msgs);
            msgs = eBasicSetContainer((InternalEObject) newNests, SourcePackage.CBLOCK__NESTS, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, SourcePackage.CBLOCK__NESTS, newNests, newNests));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getNested() {
        if (nested == null) {
            nested = new EObjectContainmentWithInverseEList(CBlock.class, this, SourcePackage.CBLOCK__NESTED, SourcePackage.CBLOCK__NESTS);
        }
        return nested;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case SourcePackage.CBLOCK__NESTS:
                if (eContainer != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return eBasicSetContainer(otherEnd, SourcePackage.CBLOCK__NESTS, msgs);
            case SourcePackage.CBLOCK__NESTED:
                return ((InternalEList) getNested()).basicAdd(otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case SourcePackage.CBLOCK__NESTS:
                return eBasicSetContainer(null, SourcePackage.CBLOCK__NESTS, msgs);
            case SourcePackage.CBLOCK__NESTED:
                return ((InternalEList) getNested()).basicRemove(otherEnd, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
        if (eContainerFeatureID >= 0) {
            switch (eContainerFeatureID) {
            case SourcePackage.CBLOCK__NESTS:
                return ((InternalEObject) eContainer).eInverseRemove(this, SourcePackage.CBLOCK__NESTED, CBlock.class, msgs);
            default:
                return eDynamicBasicRemoveFromContainer(msgs);
            }
        }
        return ((InternalEObject) eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case SourcePackage.CBLOCK__SOURCE:
            return getSource();
        case SourcePackage.CBLOCK__NESTS:
            return getNests();
        case SourcePackage.CBLOCK__NESTED:
            return getNested();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case SourcePackage.CBLOCK__SOURCE:
            setSource((String) newValue);
            return;
        case SourcePackage.CBLOCK__NESTS:
            setNests((CBlock) newValue);
            return;
        case SourcePackage.CBLOCK__NESTED:
            getNested().clear();
            getNested().addAll((Collection) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case SourcePackage.CBLOCK__SOURCE:
            setSource(SOURCE_EDEFAULT);
            return;
        case SourcePackage.CBLOCK__NESTS:
            setNests((CBlock) null);
            return;
        case SourcePackage.CBLOCK__NESTED:
            getNested().clear();
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case SourcePackage.CBLOCK__SOURCE:
            return SOURCE_EDEFAULT == null ? source != null : !SOURCE_EDEFAULT.equals(source);
        case SourcePackage.CBLOCK__NESTS:
            return getNests() != null;
        case SourcePackage.CBLOCK__NESTED:
            return nested != null && !nested.isEmpty();
        }
        return eDynamicIsSet(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String toString() {
        if (eIsProxy())
            return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (source: ");
        result.append(source);
        result.append(')');
        return result.toString();
    }

} //CBlockImpl
