/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOLFactory.java,v 1.2.4.1 2005/10/28 04:37:27 akkina Exp $
 */
package com.ibm.etools.cobol;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.ibm.etools.cobol.COBOLPackage
 * @generated
 */
public interface COBOLFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	COBOLFactory eINSTANCE = new com.ibm.etools.cobol.impl.COBOLFactoryImpl();

	/**
	 * Returns a new object of class '<em>Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Element</em>'.
	 * @generated
	 */
	COBOLElement createCOBOLElement();

	/**
	 * Returns a new object of class '<em>Variable Length Array</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Variable Length Array</em>'.
	 * @generated
	 */
	COBOLVariableLengthArray createCOBOLVariableLengthArray();

	/**
	 * Returns a new object of class '<em>Redefining Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Redefining Element</em>'.
	 * @generated
	 */
	COBOLRedefiningElement createCOBOLRedefiningElement();

	/**
	 * Returns a new object of class '<em>Composed Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Composed Type</em>'.
	 * @generated
	 */
	COBOLComposedType createCOBOLComposedType();

	/**
	 * Returns a new object of class '<em>88 Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>88 Element</em>'.
	 * @generated
	 */
	COBOL88Element createCOBOL88Element();

	/**
	 * Returns a new object of class '<em>88 Element Value</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>88 Element Value</em>'.
	 * @generated
	 */
	COBOL88ElementValue createCOBOL88ElementValue();

	/**
	 * Returns a new object of class '<em>Alpha Numeric Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Alpha Numeric Type</em>'.
	 * @generated
	 */
	COBOLAlphaNumericType createCOBOLAlphaNumericType();

	/**
	 * Returns a new object of class '<em>Numeric Edited Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Numeric Edited Type</em>'.
	 * @generated
	 */
	COBOLNumericEditedType createCOBOLNumericEditedType();

	/**
	 * Returns a new object of class '<em>Numeric Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Numeric Type</em>'.
	 * @generated
	 */
	COBOLNumericType createCOBOLNumericType();

	/**
	 * Returns a new object of class '<em>66 Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>66 Element</em>'.
	 * @generated
	 */
	COBOL66Element createCOBOL66Element();

	/**
	 * Returns a new object of class '<em>Fixed Length Array</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Fixed Length Array</em>'.
	 * @generated
	 */
	COBOLFixedLengthArray createCOBOLFixedLengthArray();

	/**
	 * Returns a new object of class '<em>DBCS Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>DBCS Type</em>'.
	 * @generated
	 */
	COBOLDBCSType createCOBOLDBCSType();

	/**
	 * Returns a new object of class '<em>Alpha Numeric Edited Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Alpha Numeric Edited Type</em>'.
	 * @generated
	 */
	COBOLAlphaNumericEditedType createCOBOLAlphaNumericEditedType();

	/**
	 * Returns a new object of class '<em>Alphabetic Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Alphabetic Type</em>'.
	 * @generated
	 */
	COBOLAlphabeticType createCOBOLAlphabeticType();

	/**
	 * Returns a new object of class '<em>Object Reference Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Object Reference Type</em>'.
	 * @generated
	 */
	COBOLObjectReferenceType createCOBOLObjectReferenceType();

	/**
	 * Returns a new object of class '<em>Source Text</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Source Text</em>'.
	 * @generated
	 */
	COBOLSourceText createCOBOLSourceText();

	/**
	 * Returns a new object of class '<em>Unicode Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Unicode Type</em>'.
	 * @generated
	 */
	COBOLUnicodeType createCOBOLUnicodeType();

	/**
	 * Returns a new object of class '<em>Internal Float Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Internal Float Type</em>'.
	 * @generated
	 */
	COBOLInternalFloatType createCOBOLInternalFloatType();

	/**
	 * Returns a new object of class '<em>External Float Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>External Float Type</em>'.
	 * @generated
	 */
	COBOLExternalFloatType createCOBOLExternalFloatType();

	/**
	 * Returns a new object of class '<em>Addressing Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Addressing Type</em>'.
	 * @generated
	 */
	COBOLAddressingType createCOBOLAddressingType();

	/**
	 * Returns a new object of class '<em>Element Initial Value</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Element Initial Value</em>'.
	 * @generated
	 */
	COBOLElementInitialValue createCOBOLElementInitialValue();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	COBOLPackage getCOBOLPackage();

} //COBOLFactory
